﻿Public Class frmTryCatchExamples

   
    Private Sub btnFTPercent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFTPercent.Click
        'Try-Catch example to handle no data errors
        'Uses free throws as an example

        'Declarations
        Dim shoFTAttempts As Short
        Dim shoFTMade As Short
        Dim sngFTPercent As Single

        Try
            'Input
            shoFTAttempts = Convert.ToInt16(txtFTAttempts.Text)
            shoFTMade = Convert.ToInt16(txtFTMade.Text)

            'Processing
            sngFTPercent = shoFTMade / shoFTAttempts
        Catch ex As Exception
            MessageBox.Show("No data. Please enter attempts and made.", "Exception Handled", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            'Output
            lblFTPercent.Text = sngFTPercent.ToString("p1")
        End Try

    End Sub

    Private Sub btnPercent2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPercent2.Click
        'Try-Catch example to handle no data overflow
        'Uses free throws as an example

        'Declarations
        Dim shoFTAttempts2 As Short
        Dim shoFTMade2 As Short
        Dim sngFTPercent2 As Single

        Try
            'Input
            shoFTAttempts2 = Convert.ToInt16(txtFTAttempts2.Text)
            shoFTMade2 = Convert.ToInt16(txtFtMade2.Text)

            'Processing
            sngFTPercent2 = shoFTMade2 / shoFTAttempts2
        Catch ex As OverflowException
            MessageBox.Show("Too Big! Please try smaller numbers.", "Exception Handled", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            'Output
            lblFTPercent2.Text = sngFTPercent2.ToString("p1")
        End Try
    End Sub

    Private Sub btnNoFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNoFile.Click
        'Try-Catch example to handle I/O errors
        'Uses NoFile.dat as an example
        'NoFile.dat doesn't exist
        Dim srdNoFile As System.IO.StreamReader

        Try
            srdNoFile = New System.IO.StreamReader("NoFile.dat")

        Catch ex As IO.FileNotFoundException
            MessageBox.Show("Sorry, no file was found.", "Exception Handled", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        End Try

    End Sub

   
    Private Sub btnNoDirectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNoDirectory.Click
        'Try-Catch example to handle I/O errors
        'Uses NoSuchDir as an example
        'NoSuchDir doesn't exist
        Dim srdNoFile As System.IO.StreamReader

        Try
            srdNoFile = New System.IO.StreamReader("NoSuchDir\NoFile.dat")

        Catch ex As IO.DirectoryNotFoundException
            MessageBox.Show("Sorry, I can't find that directory.", "Exception Handled", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        End Try

    End Sub

    Private Sub btnNoDrive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNoDrive.Click
        'Try-Catch example to handle I/O errors
        'Uses Drive U: as an example
        'Drive U: doesn't exist
        Dim srdNoFile As System.IO.StreamReader

        Try
            srdNoFile = New System.IO.StreamReader("U:\NoFile.dat")

        Catch ex As IO.DirectoryNotFoundException
            MessageBox.Show("Sorry, I can't find that drive.", "Exception Handled", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        End Try

    End Sub

    Private Sub btnClosedFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClosedFile.Click
        'Try-Catch example to handle I/O errors
        'Tries to read a closed file
        Dim srdNoFile As System.IO.StreamReader

        Try
            srdNoFile = New System.IO.StreamReader("Empty.dat")
            srdNoFile.Close()
            srdNoFile.ReadLine()
        Catch ex As Exception
            MessageBox.Show("Oops, there was a problem.", "Exception Handled", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        End Try

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End

    End Sub
End Class
